Subject: Re: [Tsvwg] A question of Un-Ordered SCTP

From: "Brian F. G. Bidulock" <[email-masked]>
Date: Wed, 12 Feb 2003 02:43:54 -0700

Michael,

Tuexen Michael wrote:                                                               (Wed, 12 Feb 2003 09:39:41)
> > 
> > I think it would be good to see the requirement that the sequence
> > number begin at 1 and be monotonically increasing in the saem fashion
> > as ordered streams.
> > 
> I would prefer that the two sequence spaces are handled the same
> way. Thus both start with SSN=0.

That would make it impossible to distinguish between SCTP's supporting
the feature and SCTP's not supporting the feature on the first message
in a stream.

Leaving '0' for unordered packets of unspecified transmission order has
some value for backwards compatibility and interoperability.

--brian

-- 
Brian F. G. Bidulock
[email-masked]
http://www.openss7.org/
_______________________________________________
tsvwg mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/tsvwg

---

From: Tuexen Michael <[email-masked]>
Date: Wed, 12 Feb 2003 09:39:41 +0100

Brian,
see my comments below.
Best regards
Michael

Michael Tuexen   Tel.:   +49 89 722 47210
Siemens AG       Fax:    +49 89 722 48212
ICN CP SE C 7    e-mail: [email-masked]

> -----Original Message-----
> From: Brian F. G. Bidulock [mailto:[email-masked]]
> Sent: Wednesday, February 12, 2003 3:16 AM
> To: Randall Stewart
> Cc: Michael Tuexen; Caitlin Bestler; [email-masked]; Tuexen Michael;
> [email-masked]
> Subject: Re: [Tsvwg] A question of Un-Ordered SCTP
> 
> 
> Randall,
> 
> I agree to having SCTP set the sequence number and, as you said in
> your first note, SCTP passing the sequence number to the ULP on
> the receiving side is already done for ordered traffic.  Some even
> pass the zero now.
> 
> I suppose that SCTP would set this sequence number when it is given
> the data for delivery at the sending ULP and the sequence 
> would represent
> the order that the data was presented to SCTP by the ULP at 
> the sending
> side.
> 
> That way RDDP and other applications could perform their own 
> reordering
> at the receiver.  I think it would be a good thing to have SCTP set
> this value.
> 
> In fact, I can see another application for this feature.  M2PA
> (SIGTRAN protocol) needs in some circumstances to send data unordered
> with the hope of expedited delivery (does not want control information
> stuck behind large amounts of data in an ordered stream), however, the
> order of processing of the expedited control information is important.
> 
> This facility would permit M2PA to send such information unordered
> to expedite it and the receiver could perform the reordering itself.
> Up until now, the only solution was to place a sequence number in with
> the control information.
> 
> Could we perhaps add a section to the SCTP IG.  "Problem statement:
> the sender wishes to send unordered data but the receive needs to know
> the original order of sending..." or some such.
> 
> It should be quite simple to add the feature to existing SCTP
> implementations.
> 
> --brian
> 
> 
> On Tue, 11 Feb 2003, Randall Stewart wrote:
> 
> > Michael:
> > 
> > This seems like a valid method.. it gets around Brian's objection
> > (which was a good point) and yet still provides the application with
> > a hint about what the assigned sequence order was on the unordered
> > messages...
> > 
> > R
> > 
> > Michael Tuexen wrote:
> > > Caitlin,
> > > 
> > > thank you very much for the clarification.
> > > 
> > > I do not like the idea to pass the SSN transparently from 
> the ULP to the 
> > > ULP.
> > > But having two sequence spaces is OK for me. This means 
> that the SSN at the
> > > sending side is controlled by the SCTP and given to the 
> ULP at the 
> > > receiving side.
> > > 
> > > This would be a clean solution. So I voting for have two 
> separate number 
> > > spaces
> > > for user data. Since the one for ordered delivery exists 
> already in RFC 
> > > 2960, this
> > > only means that a new one is introduced for the unordered 
> delivery user 
> > > data.
> > > 
> > > Best regards
> > > Michael
> > > 
> > > On Tuesday, Feb 11, 2003, at 17:37 Europe/Berlin, Caitlin 
> Bestler wrote:
> > > 
> > >> On 2/11/03, Tuexen Michael wrote:
> > >>
> > >>> Dear all,
> > >>>
> > >>> does this mean that you want two sequence spaces per
> > >>> stream: one for the 'ordered' user data and one for the
> > >>> unordered user data?
> > >>>
> > >> The RDDP/SCTP adaptation only uses unordered delivery, so
> > >> that question did not really arise.
> > >>
> > >> But if you were to generalize the problem, I believe the
> > >> answer would be yes.
> > >>
> > >> The SSN for ordered delivery would be unchanged. The
> > >> addition would be providing "advisory ordering" for
> > >> unordered delivery. The general characteristic is that
> > >> the receiving ULP wants the data in whatever order it
> > >> arrives, but wants to know what the original order was.
> > >>
> > >> In addition to RDDP, RTP over UDP is another example of
> > >> an application that wants to be aware of the original
> > >> ordering, even while accepting the data out-of-order.
> > >>
> > >> Caitlin Bestler
> > >> http://asomi.com/CaitlinBestler/
> > Randall R. Stewart
> > [email-masked] 815-342-5222 (cell phone)
> > 
> Brian F. G. Bidulock    ¦ The reasonable man adapts himself to the ¦
> [email-masked]    ¦ world; the unreasonable one persists in  ¦
> http://www.openss7.org/ ¦ trying  to adapt the  world  to himself. ¦
>                         ¦ Therefore  all  progress  depends on the ¦
>                         ¦ unreasonable man. -- George Bernard Shaw ¦
>